#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: USRP Dual Source__B
# Author: Karthik Vijayraghavan
# Description: USRP Dual Source 
# Generated: Thu Oct 29 20:14:12 2009
##################################################

from gnuradio import gr
from gnuradio import usrp,gru

class usrp_dual_source_b_f(gr.hier_block2):

	def __init__(self, fusb_block_size=512*8, fusb_nblocks=512*8, gain_a=0, gain_b=0, decimation=8):
		gr.hier_block2.__init__(
			self, "USRP Dual Source__B",
			gr.io_signature(0, 0, 0*0),
			gr.io_signature(2, 2, gr.sizeof_float*1),
		)

		##################################################
		# Parameters
		##################################################
		self.fusb_block_size = fusb_block_size
		self.fusb_nblocks = fusb_nblocks
		self.gain_a = gain_a
		self.gain_b = gain_b
		self.decimation = decimation

		##################################################
		# Blocks
		##################################################
		self.gr_complex_to_float_0 = gr.complex_to_float(1)
		self.usrp_dual_source_helper_0 = usrp.source_c(decim_rate=decimation,nchan=1,fusb_block_size=fusb_block_size,fusb_nblocks=fusb_nblocks)
		self.usrp_dual_source_helper_0.set_dc_offset_cl_enable(int(0),int(15))
		self.subdev_spec = (1,2)
		self.subdev_a = self.usrp_dual_source_helper_0.selected_subdev((1,0))
		self.subdev_b = self.usrp_dual_source_helper_0.selected_subdev((1,1))
		self.subdev = self.usrp_dual_source_helper_0.selected_subdev(self.subdev_spec)
		self.usrp_dual_source_helper_0.set_mux(self.usrp_dual_source_helper_0.determine_rx_mux_value(self.subdev_spec))
		self.subdev_a.set_gain(gain_a)
		self.subdev_b.set_gain(gain_b)
		self.usrp_dual_source_helper_0.set_rx_freq(0,0.0)
			

		##################################################
		# Connections
		##################################################
		self.connect((self.usrp_dual_source_helper_0, 0), (self.gr_complex_to_float_0, 0))
		self.connect((self.gr_complex_to_float_0, 0), (self, 0))
		self.connect((self.gr_complex_to_float_0, 1), (self, 1))

	def set_fusb_block_size(self, fusb_block_size):
		self.fusb_block_size = fusb_block_size

	def set_fusb_nblocks(self, fusb_nblocks):
		self.fusb_nblocks = fusb_nblocks

	def set_gain_a(self, gain_a):
		self.gain_a = gain_a

	def set_gain_b(self, gain_b):
		self.gain_b = gain_b

	def set_decimation(self, decimation):
		self.decimation = decimation


